Demo = {}
Demo.__index = Demo

function Demo:new()
    local o = {}
    setmetatable(o, Demo)
    o.iStage = 0
    o.stage = StageSync:new()
    return o
end

-- return boolean [isFinished]
function Demo:update()
    isFinished = false
    if self.stage:update() then
        self.iStage = self.iStage + 1
        if self.iStage == 1 then            
            self.stage = StagePreprocess:new()
        elseif self.iStage == 2 then
            self.stage = StageIdent:new()
        elseif self.iStage == 3 then
            scene = Scene:new()
            self.stage = StageScript:new(SCRIPT, scene)
        elseif self.iStage == 4 then
            self.stage = StageCredits:new()
        else
            isFinished = true
        end
    end

    return isFinished
end

function Demo:draw()
    self.stage:draw()
end
